
<?php
require_once('SHAPaydollarSecure.php');
function curlPost($url, $curlPost, $timeout = 30)
{
	$ssl = substr($url, 0, 8) == "https://" ? TRUE : FALSE;
	$ch = curl_init();
	 
	 
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $curlPost);
	curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
 
	if ($ssl)
	{
		 	
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	}
	 
	$data = curl_exec($ch);
	curl_close($ch);
	return $data;
}

//Required Parameter ( with UTF-8 Encoding ) for connect to our payment interface
$merchantId='56100884';																//The merchant ID we provide to you
$orderRef=date('YmdHis');											//Merchant‘s Order Reference Number
$currCode='344';																//The currency of the payment
$amount=10;																	//Total amount your want to charge the customer [ Up to 2 decimal place ]
$payType='N';															//The payment type:“N” – Normal Payment (Sales);“H” – Hold Payment (Authorize only)
$lang="E";																			//The language of the payment page
$pMethod="VISA";															//The payment card type
$cardNo="4918914107195005";									//Credit card number
$securityCode="123";														//Credit Card Verification Code
$epMonth="07";																//Credit card expiry month
$epYear="2015";																//Credit card expiry year
$cardHolder="Test Card";												//Credit card holder name
//Optional Parameter for connect to our payment interface

$remark="remark";															//An additional remark field that will appear in the confirmation email and transaction detail report to help you to refer the order

$isSecureHashSetting=true;
$secureHashSecret='bZe67kcltBHsrmW9EvnnscrdMuNc1HPU';  //offered by paydollar
$paydollarSecure=new SHAPaydollarSecure(); 
//Secure hash is used to authenticate the integrity of the transaction information and the identity of the merchant. It is calculated by hashing the combination of various transaction parameters and the Secure Hash Secret.
$secureHash=$paydollarSecure->generatePaymentSecureHash($merchantId, $orderRef, $currCode, $amount, $payType, $secureHashSecret);

//Parameter For 3D Transaction (Need to install MPI Server Software at Merchants’ site)
$is3D=FALSE;
$vbvTransaction="";														//3D Transaction (i.e. Verified By VISA, MasterCard SecureCode, J/Secure)
$vbvCHReturnCode="";													//Verify Enrollment Return Code
$vbvPAReturnCode="";													//Payer Authentication Return Code
$vbvTransTime="";															//Transaction Time, time, MPI PA Response Message
$vbvTransAuth="";															//Cardholder Authentication Verification Value, CAVV, value in MPI PA Response Message [ Must be in Base64-Encoded format ]
$vbvTransECI="";																//Electronic Commerce Indicator, ECI, value in MPI PA Response Message
$vbvCAVVAlgo="";															//CAVV Algorithm, cavvAlgorithm, in MPI PA Response Message
$vbvXID="";																		//Transaction Identifier, xid, in MPI PA Response Message [ Must contain 20 characters ]
$vbvMerchantID="";														//Acquirer-defined Merchant Identifier, merID, in MPI PA Response Message
$vbvAcquirerBin="";														//Acquirer BIN, acqBIN, in MPI PA Response Message
$vbvTransStatus="";														//Transaction Status, status, in MPI PA Response Message

$postData='lang='.urlencode($lang).'&merchantId='.urlencode($merchantId).'&orderRef='.urlencode($orderRef).'&currCode='.urlencode($currCode).'&amount='.urlencode($amount).'&payType='.urlencode($payType).'&remark='.urlencode($remark).'&pMethod='.urlencode($pMethod).'&cardNo='.urlencode($cardNo).'&securityCode='.urlencode($securityCode).'&epMonth='.urlencode($epMonth).'&epYear='.urlencode($epYear).'&cardHolder='.urlencode($cardHolder);

if($isSecureHashSetting){//if Secure Hash is used
	$postData=$postData.'&secureHash='.urlencode($secureHash);
}

if($is3D){
	$postData=$postData.'&vbvTransaction='.urlencode($vbvTransaction).'&vbvCHReturnCode='.urlencode($vbvCHReturnCode).'&vbvPAReturnCode='.urlencode($vbvPAReturnCode).'&vbvTransTime='.urlencode($vbvTransTime).'&vbvTransAuth='.urlencode($vbvTransAuth).'&vbvTransECI='.urlencode($vbvTransECI).'&vbvCAVVAlgo='.urlencode($vbvCAVVAlgo).'&vbvXID='.urlencode($vbvXID).'&vbvMerchantID='.urlencode($vbvMerchantID).'&vbvAcquirerBin='.urlencode($vbvAcquirerBin).'&vbvTransStatus='.urlencode($vbvTransStatus);
	
}

echo $postData;
echo '<br/>';

//post data to Paydollar System,and get the result
$data = curlPost('https://test.paydollar.com/b2cDemo/eng/directPay/payComp.jsp', $postData);

echo ('response Data='.$data);

$result=explode('&', $data);
$resultArray=array();
foreach ($result as $key=>$value){
	$empArray=explode('=', $value);
	
	$length=count($empArray);
	
	if($length==2){
		$resultArray[$empArray[0]]=$empArray[1];
	}
	
	if($length==1){
		$resultArray[$empArray[0]]='';
	}
}

 

if('0'==$resultArray['successcode']){
	// Transaction Accepted
		// *** Add the Security Control here, to check the currency, amount with the 
		// *** merchant’s order reference from your database, if the order exist then 
		// *** accepted otherwise rejected the transaction.

		//  Update your database for Transaction Accepted and send email or notify your 
		//   customer.
		....

		// In case if your database or your system got problem, you can send a void transaction request. See API guide for more details
	echo 'Payment Sucessfully';
}else{
	// Transaction Rejected
		// Update your database for Transaction Rejected
		.....
	echo 'Payment Fail';
}

?>


